require 'rails'

module Struggle
  module Generators
    class BackupConfigGenerator < Rails::Generators::Base
      desc "create backup export config file"
      def create_backup_config
        libdir = File.expand_path(File.dirname(__FILE__))
        backup_config = File.expand_path("../../templates/backup.yml", libdir)
        FileUtils.cp(backup_config, "config/backup.yml")
      end
    end
  end
end
