require 'rails'

module Struggle
  module Generators
    class SqlConfigGenerator < Rails::Generators::Base
      desc "create sql export config file"
      def create_sql_config
        libdir = File.expand_path(File.dirname(__FILE__))
        sqlconfig = File.expand_path("../../templates/tsql_config.yml", libdir)
        FileUtils.cp(sqlconfig, "config/tsql_config.yml")
      end
    end
  end
end
