module Struggle
end
begin
  require 'rails'
rescue LoadError
  #do nothing
end
# require 'zip'
require 'struggle/tfile'
require 'struggle/http'
require 'struggle/logistic'
require 'struggle/pager'
require 'struggle/sms'
require 'struggle/tmagick'
require 'struggle/code'
require 'struggle/aes'
require 'struggle/rsa'
require 'struggle/getui'
require 'struggle/concerns/string_extend'
require 'struggle/concerns/int_extend'
require 'struggle/concerns/decimal_extend'
require 'struggle/concerns/time_extend'
require 'struggle/concerns/model_extend'
require "struggle/ftp_tool"
require "struggle/translate"
require "struggle/zip_tool"
require 'struggle/sql'
require 'struggle/backup'
require 'pay/jd_gateway'

ActiveRecord::Base.send :include, Struggle::ModelExtend
String.send :include, Struggle::StringExtend
Integer.send :include, Struggle::IntExtend
Numeric.send :include, Struggle::DecimalExtend
Time.send :include, Struggle::TimeExtend
